[![npm](https://img.shields.io/npm/v/happner.svg)](https://www.npmjs.com/package/happner) [![Build Status](https://travis-ci.org/happner/happner.svg?branch=master)](https://travis-ci.org/happner/happner) [![Build status](https://ci.appveyor.com/api/projects/status/e5yrnt4fca59hksc/branch/master?svg=true)](https://ci.appveyor.com/project/happner/happner/branch/master)[![Coverage Status](https://coveralls.io/repos/happner/happner/badge.svg?branch=develop&service=github)](https://coveralls.io/github/happner/happner?branch=master) [![David](https://img.shields.io/david/happner/happner.svg)]()

<img src="https://raw.githubusercontent.com/happner/happner-website/master/images/HAPPNER%20Logo.png" width="300"></img>

Happner is a cloud application framework ideal for integrating multiple micro services into a unified offering. It enables the creation of an interconnected mesh of local and remote components. The mesh components can easily call upon each other's methods or listen to each other's events in a manner uncomplicated by remoteness.

HAPPNER-2 RELEASED
-------------------
*this version makes use of [happn-3](https://github.com/happner/happn-3) as part of its data layer, the repo can be found [here](https://github.com/happner/happner-2), with a [migration plan](https://github.com/happner/happner-2/blob/master/docs/migration-plan.md).*

## installation
```bash
npm install happner --save
```
## demonstration

These walkthroughs use *happner* to create a rudimentary monitoring service.

* [The Basics](https://github.com/happner/happner/blob/master/docs/walkthrough/the-basics.md)


## documentation

* [Configuation](https://github.com/happner/happner/blob/master/docs/configuration.md)
* [Datalayer](https://github.com/happner/happner/blob/master/docs/datalayer.md)
* [Modules and Components](https://github.com/happner/happner/blob/master/docs/modules.md)
* [Autoloading and Defaulting](https://github.com/happner/happner/blob/master/docs/autoload.md)
* [Security](https://github.com/happner/happner/blob/master/docs/security.md)

###

* [Event Api](https://github.com/happner/happner/blob/master/docs/event.md)
* [Exchange Api](https://github.com/happner/happner/blob/master/docs/exchange.md)
* [Data Api](https://github.com/happner/happner/blob/master/docs/data.md)
* [Web Routes](https://github.com/happner/happner/blob/master/docs/webroutes.md)
* [REST component](https://github.com/happner/happner/blob/master/docs/restcomponent.md)

###

* [Starting and Stopping Mesh Node](https://github.com/happner/happner/blob/master/docs/starting.md)
* [Mesh events](https://github.com/happner/happner/blob/master/docs/mesh-events.md)
* [Using the loader to start a mesh](https://github.com/happner/happner/blob/master/docs/loader.md)
* [System Components](https://github.com/happner/happner/blob/master/docs/system.md)
* [Using the Client](https://github.com/happner/happner/blob/master/docs/client.md)
